// Set.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

// O Continer associativo 'set'  usado para armazenagem e recuperao rpidas com chaves
// nicas (elementos nicos). A implementao de um 'set'  identifa aquela de um 'multiset', 
// exceto pelo fato de que um 'set', a duplicata  ignorada; como este  o comportamento 
// matemtico objetivado para um set, no o identificamos como um erro comum de programao. 
// Um set suporta iteradores bidirecionais (mas no de acesso aleatrio). 


int _tmain(int argc, _TCHAR* argv[])
{
	typedef std::set< double, std::less< double > > Conjunto_Reais;

	const int TAMANHO = 5;

	double a [ TAMANHO ] = { 2.1, 4.2, 9.5, 2.1, 3.7 };
	
	Conjunto_Reais ConjReais1( a, a + TAMANHO);

	std::ostream_iterator< double > Saida ( cout, " " );

	cout << "ConjReais1 contm: ";
	std::copy( ConjReais1.begin(), ConjReais1.end(), Saida );
	cout << endl << endl;

	std::pair< Conjunto_Reais::const_iterator, bool > par;

	// **********************************************************
	par = ConjReais1.insert( 13.8 ); // Valor no est no conjunto.
	cout << *( par.first )
		 << ( par.second ? " foi" : " no foi" ) << " inserido" << endl;

	cout << "ConjReais1 contm: ";

	std::copy( ConjReais1.begin(), ConjReais1.end(), Saida );
	cout << endl << endl;

	// **********************************************************
	par = ConjReais1.insert( 9.5 ); // Valor j est no conjunto.
    cout << *( par.first )
		 << ( par.second ? " foi" : " no foi" ) << " inserido" << endl;
	cout << "ConjReais1 contm: ";
	std::copy( ConjReais1.begin(), ConjReais1.end(), Saida );
	cout << endl << endl;

	return 0;
}

